org.apache.commons.imaging.formats.psd

## Class PsdImageParser

- java.lang.Object
- - org.apache.commons.imaging.common.BinaryFileParser
  - - org.apache.commons.imaging.ImageParser
    - - org.apache.commons.imaging.formats.psd.PsdImageParser

- All Implemented Interfaces:
    XmpEmbeddable

      public class PsdImageParser
      extends ImageParser
      implements XmpEmbeddable

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `BLOCK_NAME_XMP`
    `static int` | `IMAGE_RESOURCE_ID_ICC_PROFILE`
    `static int` | `IMAGE_RESOURCE_ID_XMP`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PsdImageParser()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `dumpImageFile(PrintWriter pw, ByteSource byteSource)` Write the ImageInfo and format-specific information for the image content of the specified byte source to a PrintWriter
    `protected String[]` | `getAcceptedExtensions()` Get an array of all accepted extensions
    `protected ImageFormat[]` | `getAcceptedTypes()` Get an array of ImageFormat objects describing all accepted types
    `BufferedImage` | `getBufferedImage(ByteSource byteSource, Map<String,Object> params)` Gets a buffered image specified by the byte source (for sources that specify multiple images, choice of which image is returned is implementation dependent).
    `String` | `getDefaultExtension()` Get the default extension for the format specified by an implementation of ImageParser.
    `byte[]` | `getICCProfileBytes(ByteSource byteSource, Map<String,Object> params)` Get an array of bytes describing the International Color Consortium (ICC) specification for the color space of the image contained in the input byteSource.
    `ImageInfo` | `getImageInfo(ByteSource byteSource, Map<String,Object> params)` Get image information from the specified ByteSource.
    `Dimension` | `getImageSize(ByteSource byteSource, Map<String,Object> params)` Get the size of the image described by the specified ByteSource.
    `ImageMetadata` | `getMetadata(ByteSource byteSource, Map<String,Object> params)` Get image metadata from the specified byte source.
    `String` | `getName()` Get a descriptive name for the implementation of an ImageParser.
    `String` | `getXmpXml(ByteSource byteSource, Map<String,Object> params)` Extracts embedded XML metadata as XML string.

    - ### Methods inherited from class org.apache.commons.imaging.ImageParser

      `canAcceptExtension, canAcceptExtension, canAcceptType, dumpImageFile, dumpImageFile, dumpImageFile, getAllBufferedImages, getAllBufferedImages, getAllBufferedImages, getAllImageParsers, getBufferedImage, getBufferedImage, getBufferedImageFactory, getFormatCompliance, getFormatCompliance, getFormatCompliance, getICCProfileBytes, getICCProfileBytes, getICCProfileBytes, getICCProfileBytes, getImageInfo, getImageInfo, getImageInfo, getImageSize, getImageSize, getImageSize, getImageSize, getMetadata, getMetadata, getMetadata, getMetadata, getMetadata, isStrict, writeImage`

    - ### Methods inherited from class org.apache.commons.imaging.common.BinaryFileParser

      `debugNumber, debugNumber, getByteOrder, setByteOrder`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### IMAGE_RESOURCE_ID_ICC_PROFILE

          public static final int IMAGE_RESOURCE_ID_ICC_PROFILE

      See Also:
        Constant Field Values

    - #### IMAGE_RESOURCE_ID_XMP

          public static final int IMAGE_RESOURCE_ID_XMP

      See Also:
        Constant Field Values

    - #### BLOCK_NAME_XMP

          public static final String BLOCK_NAME_XMP

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### PsdImageParser

          public PsdImageParser()

  - ### Method Detail

    - #### getName

          public String getName()

      Description copied from class: `ImageParser`
      Get a descriptive name for the implementation of an ImageParser.
      Specified by:
        `getName` in class `ImageParser`
      Returns:
        a valid, subject-matter-specific string.

    - #### getDefaultExtension

          public String getDefaultExtension()

      Description copied from class: `ImageParser`
      Get the default extension for the format specified by an implementation of ImageParser. Some parsers can support more than one extension (i.e. .JPEG, .JPG; .TIF, .TIFF, etc.).
      Specified by:
        `getDefaultExtension` in class `ImageParser`
      Returns:
        A valid string.

    - #### getAcceptedExtensions

          protected String[] getAcceptedExtensions()

      Description copied from class: `ImageParser`
      Get an array of all accepted extensions
      Specified by:
        `getAcceptedExtensions` in class `ImageParser`
      Returns:
        A valid array of one or more elements.

    - #### getAcceptedTypes

          protected ImageFormat[] getAcceptedTypes()

      Description copied from class: `ImageParser`
      Get an array of ImageFormat objects describing all accepted types
      Specified by:
        `getAcceptedTypes` in class `ImageParser`
      Returns:
        A valid array of one or more elements.

    - #### getICCProfileBytes

          public byte[] getICCProfileBytes(ByteSource byteSource,
                                           Map<String,Object> params)
                                    throws ImageReadException,
                                           IOException

      Description copied from class: `ImageParser`
      Get an array of bytes describing the International Color Consortium (ICC) specification for the color space of the image contained in the input byteSource. Not all formats support ICC profiles.
      Specified by:
        `getICCProfileBytes` in class `ImageParser`
      Parameters:
        `byteSource` - A valid ByteSource.
        `params` - Optional instructions for special-handling or interpretation of the input data.
      Returns:
        If available, a valid array of bytes; otherwise, a null
      Throws:
        `ImageReadException` - In the event that the specified content does not conform to the format of the specific parser implementation.
        `IOException` - In the event of unsuccessful read or access operation.

    - #### getImageSize

          public Dimension getImageSize(ByteSource byteSource,
                                        Map<String,Object> params)
                                 throws ImageReadException,
                                        IOException

      Description copied from class: `ImageParser`
      Get the size of the image described by the specified ByteSource.
      Specified by:
        `getImageSize` in class `ImageParser`
      Parameters:
        `byteSource` - A valid reference to a ByteSource.
        `params` - Optional instructions for special-handling or interpretation of the input data.
      Returns:
        A valid instance of Dimension.
      Throws:
        `ImageReadException` - In the event that the specified content does not conform to the format of the specific parser implementation.
        `IOException` - In the event of unsuccessful read or access operation.

    - #### getMetadata

          public ImageMetadata getMetadata(ByteSource byteSource,
                                           Map<String,Object> params)
                                    throws ImageReadException,
                                           IOException

      Description copied from class: `ImageParser`
      Get image metadata from the specified byte source. Format-specific ImageParser implementations are expected to return a valid IImageMetadata object or to throw an ImageReadException if unable to process the specified byte source.

      The params argument provides a mechanism for individual implementations to pass optional information into the parser. Not all formats will require this capability. Because the base class may call this method with a null params argument, implementations should always include logic for ignoring null input.

      Specified by:
        `getMetadata` in class `ImageParser`
      Parameters:
        `byteSource` - A valid byte source.
        `params` - Optional instructions for special-handling or interpretation of the input data (null objects are permitted and must be supported by implementations).
      Returns:
        A valid, potentially subject-matter-specific implementation of the IImageMetadata interface describing the content extracted from the source content.
      Throws:
        `ImageReadException` - In the event that the ByteSource content does not conform to the format of the specific parser implementation.
        `IOException` - In the event of unsuccessful data read operation.

    - #### getImageInfo

          public ImageInfo getImageInfo(ByteSource byteSource,
                                        Map<String,Object> params)
                                 throws ImageReadException,
                                        IOException

      Description copied from class: `ImageParser`
      Get image information from the specified ByteSource. Format-specific ImageParser implementations are expected to return a valid ImageInfo object or to throw an ImageReadException if unable to process the specified data.

      The params argument provides a mechanism for individual implementations to pass optional information into the parser. Not all formats will require this capability. Because the base class may call this method with a null params argument, implementations should always include logic for ignoring null input.

      Specified by:
        `getImageInfo` in class `ImageParser`
      Parameters:
        `byteSource` - A valid ByteSource object
        `params` - Optional instructions for special-handling or interpretation of the input data (null objects are permitted and must be supported by implementations).
      Returns:
        A valid image information object describing the content extracted from the specified data.
      Throws:
        `ImageReadException` - In the event that the specified content does not conform to the format of the specific parser implementation.
        `IOException` - In the event of unsuccessful data access operation.

    - #### dumpImageFile

          public boolean dumpImageFile(PrintWriter pw,
                                       ByteSource byteSource)
                                throws ImageReadException,
                                       IOException

      Description copied from class: `ImageParser`
      Write the ImageInfo and format-specific information for the image content of the specified byte source to a PrintWriter
      Overrides:
        `dumpImageFile` in class `ImageParser`
      Parameters:
        `pw` - print writer used for writing the ImageInfo
        `byteSource` - A valid byte source.
      Returns:
        A valid PrintWriter.
      Throws:
        `ImageReadException` - In the event that the specified content does not conform to the format of the specific parser implementation.
        `IOException` - In the event of unsuccessful read or access operation.

    - #### getBufferedImage

          public BufferedImage getBufferedImage(ByteSource byteSource,
                                                Map<String,Object> params)
                                         throws ImageReadException,
                                                IOException

      Description copied from class: `ImageParser`
      Gets a buffered image specified by the byte source (for sources that specify multiple images, choice of which image is returned is implementation dependent).
      Specified by:
        `getBufferedImage` in class `ImageParser`
      Parameters:
        `byteSource` - A valid instance of ByteSource
        `params` - Optional instructions for special-handling or interpretation of the input data (null objects are permitted and must be supported by implementations).
      Returns:
        A valid instance of BufferedImage.
      Throws:
        `ImageReadException` - In the event that the specified content does not conform to the format of the specific parser implementation.
        `IOException` - In the event of unsuccessful read or access operation.

    - #### getXmpXml

          public String getXmpXml(ByteSource byteSource,
                                  Map<String,Object> params)
                           throws ImageReadException,
                                  IOException

      Extracts embedded XML metadata as XML string.

      Specified by:
        `getXmpXml` in interface `XmpEmbeddable`
      Parameters:
        `byteSource` - File containing image data.
        `params` - Map of optional parameters, defined in ImagingConstants.
      Returns:
        Xmp Xml as String, if present. Otherwise, returns null.
      Throws:
        `ImageReadException` - In the event that the specified content does not conform to the format of the specific parser implementation.
        `IOException` - In the event of unsuccessful read or access operation.

Copyright © 2007–2020 The Apache Software Foundation. All rights reserved.